<template>
  <div>
    <TheProjectSettingsModal />
    <ProjectInstances :instances="instances" />
    <ProjectCollaborators />
    <ProjectBilling v-if="activeProject" />
  </div>
</template>

<script lang="ts">
import { Component, Vue, Prop } from "vue-property-decorator";
import ProjectBilling from "@/components/ProjectBilling.vue";
import ProjectCollaborators from "@/components/ProjectCollaborators.vue";
import ProjectInstances from "@/components/ProjectInstances.vue";
import { ServiceInstance } from "@/services/arbalo_extensions/instances";
import TheProjectSettingsModal from "@/components/TheProjectSettingsModal.vue";

@Component({
  components: {
    TheProjectSettingsModal,
    ProjectBilling,
    ProjectCollaborators,
    ProjectInstances
  }
})
export default class ProjectDashboard extends Vue {
  @Prop() projectUUID!: string;

  get instances(): ServiceInstance[] {
    return this.$store.state.catalog.instances;
  }

  get activeProject() {
    return this.$store.state.activeProject;
  }

  private async fetchInstances() {
    await this.$store.dispatch("catalog/fetchInstances", {
      projectUUID: this.$store.state.activeProject.uuid
    });
  }

  private async mounted() {
    if (this.projectUUID) {
      const project = await this.$store.getters.getProjectByUUID(
        this.projectUUID
      );
      if (project) {
        this.$store.commit("setActiveProject", project);
        await this.fetchInstances();
      }
    } else {
    }
    await this.$store.dispatch("project/fetchClientsForActiveProject");
  }
}
</script>

<style lang="scss" scoped>
</style>
